package hdl

import (
	"applet/app/customer/md"
	"applet/app/customer/svc"
	"applet/app/db"
	"applet/app/e"
	"applet/app/utils"
	"github.com/gin-gonic/gin"
)

func EducateSceneTokenQuery(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userToken := c.DefaultQuery("user_token", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}
	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	err, info := svc.CurlEducateSceneTokenQuery(md.CurlEducateSceneTokenReq{
		CertNo:        identity.IdNo,
		StudentName:   identity.Name,
		OutUserId:     utils.IntToStr(identity.Id),
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	}, identity.Id, userToken)
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateSceneTokenCreateForApplet(c *gin.Context) {
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}
	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	err, info := svc.CurlEducateSceneTokenCreateForApplet(md.CurlEducateSceneTokenReq{
		CertNo:        identity.IdNo,
		StudentName:   identity.Name,
		OutUserId:     utils.IntToStr(identity.Id),
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateFacepayApply(c *gin.Context) {
	faceOpenId := c.DefaultQuery("face_open_id", "")
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}

	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	selfSupportForUserFaceInfoDb := db.SelfSupportForUserFaceInfoDb{}
	selfSupportForUserFaceInfoDb.Set(utils.StrToInt(userIdentityId))
	faceInfo, err := selfSupportForUserFaceInfoDb.GetSelfSupportForUserFaceInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if faceInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前用户身份未查询到一脸通行相关数据")
		return
	}
	err, info := svc.CurlEducateFacepayApply(md.CurlEducateFacepayApplyReq{
		FaceUid:       faceInfo.UserId,
		FaceOpenId:    faceOpenId,
		SchoolStdCode: selfSupportForSchoolInfo.SchoolStdCode,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}

func EducateSceneTokenCreateForConcentratedCollectApplet(c *gin.Context) {
	user := svc.GetUser(c)
	userIdentityId := c.DefaultQuery("user_identity_id", "")
	userIdentityDb := db.UserIdentityDb{}
	userIdentityDb.Set(0)
	identity, err := userIdentityDb.GetUserIdentity(utils.StrToInt(userIdentityId))
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}

	selfSupportForSchoolInfoDb := db.SelfSupportForSchoolInfoDb{}
	selfSupportForSchoolInfoDb.Set(identity.EnterpriseId)
	selfSupportForSchoolInfo, err := selfSupportForSchoolInfoDb.GetSelfSupportForSchoolInfo()
	if err != nil {
		e.OutErr(c, e.ERR_DB_ORM, err.Error())
		return
	}
	if selfSupportForSchoolInfo == nil {
		e.OutErr(c, e.ERR_NO_DATA, "当前学校暂未完成《一脸通行入驻》")
		return
	}
	//请求支付宝 alipay.commerce.educate.scene.token.query(查询刷脸用户开通详细信息)
	err, info := svc.CurlEducateSceneTokenCreateForConcentratedCollectApplet(md.CurlEducateSceneTokenReq{
		CertNo:         identity.IdNo,
		StudentName:    identity.Name,
		OutUserId:      utils.IntToStr(identity.Id),
		SchoolStdCode:  selfSupportForSchoolInfo.SchoolStdCode,
		OperatorUserId: user.UserId,
	})
	if err != nil {
		e.OutErr(c, e.ERR, err.Error())
		return
	}
	e.OutSuc(c, info, nil)
	return
}
